import { Vector } from "@bearmetal/doodler";
import { TrackSegment } from "./track/system.ts";

declare global {
  type End = {
    pos: Vector;
    segment: TrackSegment;
    tangent: Vector;
    frontOrBack: "front" | "back";
  };

  type SerializedTrackSegment = {
    p: [number, number, number][];
    id: string;
    bNeighbors: string[];
    fNeighbors: string[];
  };

  type Debug = {
    track: boolean;
    train: boolean;
    car: boolean;
    path: boolean;
    bogies: boolean;
    angles: boolean;
    aabb: boolean;
  };
}
